/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2014 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Can.c 599 2014-10-17 01:27:58Z shigihara $
 */

/* [CAN034][CAN036][CAN394][CAN397][CAN390] */
/* [CAN222] Can⥸塼ɬפʥǡ줿إåե */
#include "Os.h"
#include "ComStack_Types.h"
#include "Can.h"
#include "CanIf_Cbk.h"
#include "MemMap.h"
#include "EcuM_Cbk.h"

/*
 * (CAN077) CANȥͤ˰¸Ԥ
 * (CAN284) 1ECUʣΰۤʤCANȥѤ⡤1Ĥΰ¸б
 * (CAN385) 1ECUʣΰۤʤCANȥѤ硤AUTOSARΥ͡ߥ󥰥٥󥷥˽
 * (CAN386) 1CANȥΤߤѤ硤ȼΥ͡ߥ󥰥٥󥷥Ǥ褤
 * (CAN238) åפCANȥѤ硤¾Υɥ饤ФΥӥѤʤ
 * (CAN242) եåפCANȥѤ硤MCALΥӥѤ
 * (CAN244) MCALƤӽФ褦ʥХå󶡤ʤ
 * (CAN391) եåפCANȥѤ硤Spi.hinclude
 * (CAN204) ¸γƴؿǳ߶ػߵĤԤ硤
 *          ͥȸƽФ˽߶ػ߾֤ݻ
 */
#include "Can_Target.h"

/* SchM_Can.hRTEͥ졼ˤ */
/* [CAN034][CAN406] */
#include "SchM_Can.h"

#if CAN_DEV_ERROR_DETECT == STD_ON
/* [CAN034][CAN393] */
#include "Det.h"
#endif /* CAN_DEV_ERROR_DETECT == STD_ON */


/*
 *  ߼¹Canե졼
 */
const Can_ConfigType			*p_cur_can_config;
const Can_HohBoxType			*p_cur_hoh_box_table;
const CAN_CTRL_INIB				*p_cur_can_ctrl_inib_table;

/* [CAN103] Canν(CAN_UNINITǽ) */
static uint8					can_init_flg = CAN_UNINIT;

/* ߶ػߥͥȥ */
extern uint8					can_interrupt_nested_cnt[];

/* 륢ȴؿ */
#ifdef USE_CAN_LPDU_RECEIVE_CALLOUT_FUNCTION
extern const Can_LpduCallout	CanLpduCalloutFunction;
#endif /* USE_CAN_LPDU_RECEIVE_CALLOUT_FUNCTION */

/* Can_SetControllerModeư֥ե饰 */
extern boolean					can_set_controller_mode_flg[];

/* CANȥ־ */
extern Can_StateTransitionType	can_current_state[];

/*
 *  ؿץȥ
 */
static boolean can_check_timeout_duration(uint8 Controller, Can_StateTransitionType Transition);

/*
 *  [CAN223] Can_Init
 */
void
Can_Init(const Can_ConfigType *Config)
{
	Can_HwHandleType	hth_idx;
	Can_HwHandleType	hrh_idx;
	uint8				ctrl_id;
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* [CAN026] ˽Ѥߤξϥ顼 */
	if (can_init_flg == CAN_READY) {
		goto error_exit;
	}

	/* [CAN175] NULLå */
	if (Config == NULL_PTR) {
		/* [NCAN003] NULL_PTRξ硤ƬΥե졼Ѥ */
		Config = &can_config[0];
	}

	/* [CAN056] ¹Ԥ륳ե졼 */
	p_cur_can_config = Config;
	p_cur_hoh_box_table = Config->p_hoh_box_table;
	p_cur_can_ctrl_inib_table = Config->p_can_ctrl_inib_table;

	/*
	 * (CAN407) ʲư¸ؿɬפʥ쥸νԤ
	 * (CAN419) ѤʤƤCANߤ̵ˤ
	 * (CAN236)(CAN237) ⡼׵̵뤹褦˽Ԥ
	 * (CAN239) CANȥǻѤƤΥϡɥ꥽
	 * (CAN259) ȥSTOPPED֤ˤ
	 */

	/* [CAN245][CAN250] unit_phase1 */
	if (can_target_init_unit_phase1(p_cur_can_config) == FALSE) {
		goto error_exit;
	}

	/* [CAN245][CAN250][CAN053] ѤƤΥȥФ */
	for (ctrl_id = 0U; ctrl_id < GET_CONTROLLER_NUM(); ctrl_id++) {
		/* CANȥ֥å */
		p_ctrl_inib = GET_CAN_CTRL_INIB(ctrl_id);

		/* controller_phase1 */
		if (can_target_init_controller_phase1(ctrl_id, p_ctrl_inib) == FALSE) {
			goto error_exit;
		}

		/* ǥեȥܡ졼Ȥꤹ */
		can_target_change_baudrate(ctrl_id, p_ctrl_inib->p_default_baudrate);

		/* controller_phase2 */
		if (can_target_init_controller_phase2(ctrl_id, p_ctrl_inib) == FALSE) {
			goto error_exit;
		}

		/* ᡼ܥå */
		for (hrh_idx = 0U; hrh_idx < GET_HRH_NUM(ctrl_id); hrh_idx++) {
			if (can_target_rbox_initialize(ctrl_id, p_ctrl_inib, hrh_idx) == FALSE) {
				goto error_exit;
			}
		}

		/* ᡼ܥå */
		for (hth_idx = 0U; hth_idx < GET_HTH_NUM(ctrl_id); hth_idx++) {
			if (can_target_tbox_initialize(ctrl_id, p_ctrl_inib, hth_idx) == FALSE) {
				goto error_exit;
			}

			/* HTHΥߥ塼ƥå */
			p_ctrl_inib->p_can_hth_cb_table[hth_idx].mutex = FALSE;
		}

		/* controller_phase3 */
		if (can_target_init_controller_phase3(ctrl_id, p_ctrl_inib) == FALSE) {
			goto error_exit;
		}

		/* ߶ػߥͥȥȽ */
		can_interrupt_nested_cnt[ctrl_id] = 0U;

		/*  Can_SetControllerModeư֥ե饰 */
		can_set_controller_mode_flg[ctrl_id] = FALSE;

		/* CANȥ־ */
		can_current_state[ctrl_id] = CAN_T_STOP;
	}

	/* [CAN245][CAN250] unit_phase2 */
	if (can_target_init_unit_phase2(p_cur_can_config) == FALSE) {
		goto error_exit;
	}

	/* [CAN246] ƤνλˡCanν֤ꤹ */
	can_init_flg = CAN_READY;

  normal_exit:
	return;

  error_exit:
	/* [CAN104][CAN174][CAN408] */
	CAN_DET_REPORT_ERROR(CANServiceId_Init, CAN_E_TRANSITION);
	/* [CAN091] */
	goto normal_exit;
}


/*
 *  [CAN224] Can_GetVersionInfo
 */
/* [CAN252] Can_GetVersionInfo̵ͭϥե졼ڤؤ */
#if CAN_VERSION_INFO_API == STD_ON
/* [CAN251] ޥǼƤ褤NULLݥ󥿥åΤؿȤ */
void
Can_GetVersionInfo(Std_VersionInfoType *versioninfo)
{
	/* [CAN177] */
	if (versioninfo == NULL_PTR) {
		CAN_DET_REPORT_ERROR(CANServiceId_GetVersionInfo, CAN_E_PARAM_POINTER);
	}

	/* [CAN105] ƥС֤ */
	versioninfo->vendorID = CAN_VENDOR_ID;
	versioninfo->moduleID = CAN_MODULE_ID;
	versioninfo->sw_major_version = CAN_SW_MAJOR_VERSION;
	versioninfo->sw_minor_version = CAN_SW_MINOR_VERSION;
	versioninfo->sw_patch_version = CAN_SW_PATCH_VERSION;
}
#endif /* CAN_VERSION_INFO_API */

/* [CAN460] Can_CheckBaudrate̵ͭϥե졼ڤؤ */
#if CAN_CHANGE_BAUDRATE_API == STD_ON
/*
 *  [CAN454] Can_CheckBaudrate
 */
Std_ReturnType
Can_CheckBaudrate(uint8 Controller, const uint16 Baudrate)
{
	uint8				i;
	Std_ReturnType		ercd = E_NOT_OK;
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* [CAN104][CAN026][CAN456] */
	CAN_CHECK_INITIALIZED_ERCD_STD_RETERN_TYPE(CANServiceId_CheckBaudrate);

	/* [CAN104][CAN457] */
	CAN_CHECK_CONTROLLER_ERCD_STD_RETERN_TYPE((Controller < GET_CONTROLLER_NUM()), CANServiceId_CheckBaudrate);

	/* CANȥ֥å */
	p_ctrl_inib = GET_CAN_CTRL_INIB(Controller);

	/* ݡȥܡ졼ȤȽ */
	for (i = 0U; i < p_ctrl_inib->tnum_baudrate; i++) {
		if (p_ctrl_inib->p_baudrate_table[i].CanControllerBaudRate == Baudrate) {
			ercd = E_OK;
			break;
		}
	}

	/* [CAN458] ̤ݡȤΥܡ졼Ȥꤵ줿硤DET顼 */
	if (ercd == E_NOT_OK) {
		CAN_DET_REPORT_ERROR(CANServiceId_CheckBaudrate, CAN_E_PARAM_BAUDRATE);
	}

  error_exit:
	/* [CAN091] */
	return(ercd);
}

/*
 *  [CAN449] Can_ChangeBaudrate
 */
Std_ReturnType
Can_ChangeBaudrate(uint8 Controller, const uint16 Baudrate)
{
	uint8									i;
	Std_ReturnType							ercd = E_NOT_OK;
	const CAN_CTRL_INIB						*p_ctrl_inib;
	const Can_ControllerBaudrateConfigType	*p_baudrate_config;

	/* [CAN104][CAN026][CAN450] */
	CAN_CHECK_INITIALIZED_ERCD_STD_RETERN_TYPE(CANServiceId_ChangeBaudrate);

	/* [CAN104][CAN452] */
	CAN_CHECK_CONTROLLER_ERCD_STD_RETERN_TYPE((Controller < GET_CONTROLLER_NUM()), CANServiceId_ChangeBaudrate);

	/* CANȥ֥å */
	p_ctrl_inib = GET_CAN_CTRL_INIB(Controller);

	/* ݡȥܡ졼ȤȽ */
	for (i = 0U; i < p_ctrl_inib->tnum_baudrate; i++) {
		if (p_ctrl_inib->p_baudrate_table[i].CanControllerBaudRate == Baudrate) {
			ercd = E_OK;

			/* оݤΥܡ졼ȥꥹȼ */
			p_baudrate_config = &p_ctrl_inib->p_baudrate_table[i];
			break;
		}
	}

	if (ercd == E_OK) {
		/* ܡ졼Ȥ */
		/* (CAN062) ɬפ˱ơȥκƽԤ */
		/* (CAN461) ˥åץ٥Ȥȯ硤EcuM⥸塼Τ */
		/* (CAN255) оݤΥȥ˴ؤ쥸Τ */
		/* (CAN256) оݤΥȥ餬STOPPED֤ξΤߡܡ졼Ȥѹ */
		/* (CAN260) ܡ졼ѹ桤оݤΥȥSTOPPED֤ݻ */
		/* (CAN422) ܡ졼ѹˤäơоݤΥȥ餬ͥåȥ˻ä뤳ȤϤʤ */
		if (can_target_change_baudrate(Controller, p_baudrate_config) == FALSE) {
			ercd = E_NOT_OK;
			/* (CAN453) CANȥ餬ܡ졼ȤѹǤʤ֤ξ硤DET顼 */
			CAN_DET_REPORT_ERROR(CANServiceId_ChangeBaudrate, CAN_E_TRANSITION);
		}
	}
	else {
		/* [CAN451] ̤ݡȤΥܡ졼Ȥꤵ줿硤DET顼 */
		CAN_DET_REPORT_ERROR(CANServiceId_ChangeBaudrate, CAN_E_PARAM_BAUDRATE);
	}

  error_exit:
	/* [CAN091] */
	return(ercd);
}
#endif /* CAN_CHANGE_BAUDRATE_API == STD_ON */

/*
 *  [CAN230] Can_SetControllerMode
 */
Can_ReturnType
Can_SetControllerMode(uint8 Controller, Can_StateTransitionType Transition)
{
	Can_ReturnType		ercd = CAN_OK;
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* [CAN104][CAN026][CAN198] å */
	CAN_CHECK_INITIALIZED_ERCD_CAN_RETERN_TYPE(CANServiceId_SetControllerMode);

	/* [CAN104][CAN199] ȥIDå */
	CAN_CHECK_CONTROLLER_ERCD_CAN_RETERN_TYPE((Controller < GET_CONTROLLER_NUM()), CANServiceId_SetControllerMode);

	/* Can_SetControllerModeưե饰ư(TRUE) */
	can_set_controller_mode_flg[Controller] = TRUE;

	/* CANȥ֥å */
	p_ctrl_inib = GET_CAN_CTRL_INIB(Controller);

	/* [CAN017] ꤵ줿CANȥ֤ذܹ */
	/* [CAN398] ֥åɻߤΤˡGetCounterValueѤ⡼ѹλȽ̤ */
	/* [CAN371] CanTimeoutDurationǻꤵ줿֤ͤȤơݡ󥰤Ԥ */
	/* [CAN372] CanTimeoutDurationвᤷƤ⡼ɤڤؤʤä硤 */
	/*          Can_SetControllerModeϳ졤Can_Mainfunction_Modeˤݡ󥰤³ */
	/* (CAN196) ɬפ˱Ƴ߶ػ/ľ֤ѹ */
	/* (CAN197) ܹԸξ֤ǵĤʤߤػߤ */
	/* (CAN425) Can_DisableControllerInterruptsƤФƤ硤ߤĤʤ */
	/* (CAN426) Can_DisableControllerInterruptsƤФƤ硤ٳߤػߤʤ */
	switch (Transition) {
	case CAN_T_START:
		/*
		 * STOPPED -> STARTED
		 * (CAN261) CANȥͥåȥ˻ä
		 * (CAN409) CANȥ餬STOPPED֤ǤʤˡCAN_T_START
		 *          ꤵ줿硤DET顼Ȥ
		 * (CAN384) Can_InitCan_ChangeBaudrateǽ줿ƤǺƽ
		 */
		if (can_target_start_controller_and_change_interrupt(Controller, p_ctrl_inib) != FALSE) {
			/* [CAN281] CANȥξ֤δƻ */
			if (can_check_timeout_duration(Controller, CAN_T_START) == TRUE) {
				/* [CAN373] ̥쥤ؤ */
				CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_STARTED);

				/* оݤΥȥξ֤򹹿 */
				can_current_state[Controller] = CAN_T_START;
			}
		}
		else {
			ercd = CAN_NOT_OK;
			CAN_DET_REPORT_ERROR(CANServiceId_SetControllerMode, CAN_E_TRANSITION);
		}
		break;
	case CAN_T_STOP:
		/*
		 * STARTED -> STOPPED
		 * (CAN263) CANȥͥåȥؤλäλ
		 * (CAN282) ڥǥΥå¸ߤ硤󥻥뤹
		 * (CAN283) ڥǥΥåФ륭󥻥ΤϹԤʤ
		 * (CAN410) CANȥ餬STARTǤSTOPPED֤Ǥʤˡ
		 *          CAN_T_STOPꤵ줿硤DET顼Ȥ
		 */
		if (can_target_stop_controller_and_change_interrupt(Controller, p_ctrl_inib) != FALSE) {
			/* [CAN281] CANȥξ֤δƻ */
			if (can_check_timeout_duration(Controller, CAN_T_STOP) == TRUE) {
				/* [CAN373] ̥쥤ؤ */
				CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_STOPPED);

				/* оݤΥȥξ֤򹹿 */
				can_current_state[Controller] = CAN_T_STOP;
			}
		}
		else {
			ercd = CAN_NOT_OK;
			CAN_DET_REPORT_ERROR(CANServiceId_SetControllerMode, CAN_E_TRANSITION);
		}
		break;
	case CAN_T_SLEEP:
		/*
		 * STOPPED -> SLEEP
		 * (CAN265) CANȥSLEEP֤ڤؤ
		 * (CAN290) ϡɥSLEEP⡼ɤ򥵥ݡȤʤ硤ŪSLEEP֤Ȥ
		 * (CAN405) ŪSLEEP֤ϡCan_SetControllerMode(CAN_T_WAKEUP)ƽФˤ곫
		 * (CAN411) CANȥ餬STOPPEDǤSLEEP֤Ǥʤˡ
		 *          CAN_T_SLEEPꤵ줿硤DET顼Ȥ
		 */
		if (can_target_sleep_controller_and_change_interrupt(Controller, p_ctrl_inib) != FALSE) {
			/* [CAN281] CANȥξ֤δƻ */
			if (can_check_timeout_duration(Controller, CAN_T_SLEEP) == TRUE) {
				/* [CAN373] ̥쥤ؤ */
				CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_SLEEP);

				/* оݤΥȥξ֤򹹿 */
				can_current_state[Controller] = CAN_T_SLEEP;
			}
		}
		else {
			ercd = CAN_NOT_OK;
			CAN_DET_REPORT_ERROR(CANServiceId_SetControllerMode, CAN_E_TRANSITION);
		}
		break;
	case CAN_T_WAKEUP:
		/*
		 * SLEEP -> STOPPED
		 * (CAN267) ϡɥSLEEP⡼ɤ򥵥ݡȤʤ硤Ū
		 *          SLEEP֤ȥؤνϲԤʤ
		 * (CAN412) CANȥ餬SLEEPǤSTOPPED֤Ǥʤˡ
		 *          CAN_T_SLEEPꤵ줿硤DET顼Ȥ
		 */
		/* (CAN294) å׾֤åݤϡå׳ߤػߤ */
		/* (CAN048) SLEEP˥åפ硤ܥƥॵӥCAN_T_WAKEUPꤵƤCAN_NOT_OK֤ */
		if (can_target_wakeup_controller_and_change_interrupt(Controller, p_ctrl_inib) != FALSE) {
			/* [CAN281] CANȥξ֤δƻ */
			if (can_check_timeout_duration(Controller, CAN_T_WAKEUP) == TRUE) {
				/* [CAN373] ̥쥤ؤ */
				CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_STOPPED);

				/* оݤΥȥξ֤򹹿 */
				can_current_state[Controller] = CAN_T_WAKEUP;
			}
		}
		else {
			ercd = CAN_NOT_OK;
			CAN_DET_REPORT_ERROR(CANServiceId_SetControllerMode, CAN_E_TRANSITION);
		}
		break;
	default:
		/* [CAN200] ۾ξ */
		ercd = CAN_NOT_OK;
		CAN_DET_REPORT_ERROR(CANServiceId_SetControllerMode, CAN_E_TRANSITION);
		break;
	}

  error_exit:
	/* [CAN091] */

	/* Can_SetControllerModeưե饰(FALSE) */
	can_set_controller_mode_flg[Controller] = FALSE;

	return(ercd);
}

/*
 *  [CAN231] Can_DisableControllerInterrupts
 */
void
Can_DisableControllerInterrupts(uint8 Controller)
{
	/* [CAN104][CAN026][CAN205] */
	CAN_CHECK_INITIALIZED(CANServiceId_DisableControllerInterrupts);

	/* [CAN104][CAN206] */
	CAN_CHECK_CONTROLLER((Controller < GET_CONTROLLER_NUM()), CANServiceId_DisableControllerInterrupts);

	/* ͥȥȽ */
	if (can_interrupt_nested_cnt[Controller] == CAN_INTERRUPT_NESTED_CNT_MAX) {
		/*Ķ */
		CAN_DET_REPORT_ERROR(CANServiceId_DisableControllerInterrupts, CAN_E_FATAL);
		goto error_exit;
	}

	/*
	 * ߶ػ߽
	 * [CAN049] ߵľ֤ΥȥξΤ߽
	 */
	if (can_interrupt_nested_cnt[Controller] == 0U) {
		if (can_target_disable_controller_interrupts(Controller) == FALSE) {
			CAN_DET_REPORT_ERROR(CANServiceId_DisableControllerInterrupts, CAN_E_FATAL);
		}
	}

	/* [CAN202] ͥȸƽФԤäơտޤߵĤˤʤʤ褦ˤ */
	can_interrupt_nested_cnt[Controller]++;

  error_exit:
	/* [CAN091] */
	return;
}

/*
 *  [CAN232] Can_EnableControllerInterrupts
 */
void
Can_EnableControllerInterrupts(uint8 Controller)
{
	/* [CAN104][CAN026][CAN209] */
	CAN_CHECK_INITIALIZED(CANServiceId_EnableControllerInterrupts);

	/* [CAN104][CAN210] */
	CAN_CHECK_CONTROLLER((Controller < GET_CONTROLLER_NUM()), CANServiceId_EnableControllerInterrupts);

	/*
	 * ͥȥȽ
	 * [CAN208] DisableƤФƤʤϤʤˤ⤷ʤ
	 */
	if (can_interrupt_nested_cnt[Controller] != 0U) {
		/*
		 * ͥȥȥǥ
		 * [CAN050] ͥȸƽФԤäơտޤߵĤˤʤʤ褦ˤ
		 */
		can_interrupt_nested_cnt[Controller]--;

		if (can_interrupt_nested_cnt[Controller] == 0U) {
			/* ߵĽ */
			if (can_target_enable_controller_interrupts(Controller) == FALSE) {
				CAN_DET_REPORT_ERROR(CANServiceId_EnableControllerInterrupts, CAN_E_FATAL);
			}
		}
	}

  error_exit:
	/* [CAN091] */
	return;
}

/*
 *  [CAN360] Can_CheckWakeup
 */
Can_ReturnType
Can_CheckWakeup(uint8 Controller)
{
	Can_ReturnType ercd;

	/* [CAN104][CAN026][CAN362] */
	CAN_CHECK_INITIALIZED_ERCD_CAN_RETERN_TYPE(CANServiceId_CheckWakeup);

	/* [CAN104][CAN363] */
	CAN_CHECK_CONTROLLER_ERCD_CAN_RETERN_TYPE((Controller < GET_CONTROLLER_NUM()), CANServiceId_CheckWakeup);

	/* (CAN361) SLEEP֤ذܹԤƤ饦åפ򸡽Фɤ֤ */
	if (can_target_check_wakeup(Controller) != FALSE) {
		ercd = CAN_OK;
	}
	else {
		ercd = CAN_NOT_OK;
	}

  error_exit:
	/* [CAN091] */
	return(ercd);
}

/*
 *  [CAN233] Can_Write
 */
Can_ReturnType
Can_Write(Can_HwHandleType Hth, const Can_PduType *PduInfo)
{
	Can_ReturnType		ercd;
	uint8				ctrl_id;
	Can_HwHandleType	tbox_index;

	/* [CAN104][CAN026][CAN216] */
	CAN_CHECK_INITIALIZED_ERCD_CAN_RETERN_TYPE(CANServiceId_Write);

	/* [CAN104][CAN217] */
	CAN_CHECK_HTH_ERCD_CAN_RETERN_TYPE(((Hth < GET_HOH_NUM()) && (GET_BOX_OBJ_TYPE(Hth) == CAN_TRANSMIT)), CANServiceId_Write);

	/* [CAN104][CAN218] */
	CAN_CHECK_DLC_ERCD_CAN_RETERN_TYPE((PduInfo->length <= CAN_MAX_DLC), CANServiceId_Write);

	/* [CAN104][CAN219] */
	CAN_CHECK_SDU_ERCD_CAN_RETERN_TYPE((PduInfo->sdu != NULL_PTR), CANServiceId_Write);

	/* ȥID */
	ctrl_id = GET_CONTROLLER_ID(Hth);

	/* ᡼ܥåΥǥå */
	tbox_index = GET_BOX_IDX(Hth);

	/* [CAN011] ǡݻ뤿˽񤭹¾ */
	/* ¾ */
	SchM_Enter_Can_Reentrant();

	/* [CAN212] HTHΥߥ塼ƥåȽ */
	if (GET_HTH_MUTEX(ctrl_id, tbox_index) == FALSE) {
		/* HTHΥߥ塼ƥå */
		SET_HTH_MUTEX(ctrl_id, tbox_index, TRUE);

		ercd = CAN_OK;
	}
	else {
		/* [CAN213][CAN214][CAN215][CAN434] ߥ塼ƥåѤߤξϡCAN_BUSY֤ */
		ercd = CAN_BUSY;
	}

	/* ¾λ */
	SchM_Exit_Can_Reentrant();

	if (ercd == CAN_OK) {
		/* [CAN276] λѤPDU-IDݻ */
		SET_SAVED_PDU_ID(ctrl_id, tbox_index, PduInfo->swPduHandle);

		/*
		 * ǡڤ׵
		 * [CAN275] Τ¾»ܤʤ
		 * (CAN059) ǡ0ܤǤ7ܤǤǸ
		 * (CAN427) ϡɥΥХåեɽ˴ؤ餺Can_PduType˴ޤޤǡѤ
		 */
		ercd = can_target_transmit(ctrl_id, tbox_index, PduInfo);

		/* HTHΥߥ塼ƥå */
		SET_HTH_MUTEX(ctrl_id, tbox_index, FALSE);
	}

  error_exit:
	/* [CAN091] */
	return(ercd);
}

/*
 *  [CAN007][CAN099][CAN280][CAN225][NCAN002] Can_MainFunction_Write
 */
/* [CAN178] ݡ󥰤ˤѤʤ硤ܴؿʤ */
#ifdef USE_CAN_TX_POLLING
void
Can_MainFunction_Write(void)
{
	uint8				ctrl_id;
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* [CAN104][CAN026][CAN179] */
	CAN_CHECK_INITIALIZED_MF(CANServiceId_MainFunction_Write);

	/* [CAN031] λΤΥݡ󥰤Ԥ */
	for (ctrl_id = 0U; ctrl_id < GET_CONTROLLER_NUM(); ctrl_id++) {
		/* оݥȥ餬ݡ󥰤ξˤΤ߼¹ */
		p_ctrl_inib = GET_CAN_CTRL_INIB(ctrl_id);
		if ((p_ctrl_inib->use_polling & CAN_USE_POLLING_TX) != 0x00U) {
			if (can_target_polling_tx(ctrl_id) != FALSE) {
				Can_IsrTx(ctrl_id);
			}
		}
	}

  error_exit:
	/* [CAN091] */
	return;
}
#endif /* USE_CAN_TX_POLLING */

/*
 *  [CAN007][CAN099][CAN280][CAN226][NCAN001] Can_MainFunction_Read
 */
/* [CAN180] ݡ󥰤ˤѤʤ硤ܴؿʤ */
#ifdef USE_CAN_RX_POLLING
void
Can_MainFunction_Read(void)
{
	uint8				ctrl_id;
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* [CAN104][CAN026][CAN181] */
	CAN_CHECK_INITIALIZED_MF(CANServiceId_MainFunction_Read);

	/* [CAN108] λΤΥݡ󥰤Ԥ */
	for (ctrl_id = 0U; ctrl_id < GET_CONTROLLER_NUM(); ctrl_id++) {
		/* оݥȥ餬ݡ󥰤ξˤΤ߼¹ */
		p_ctrl_inib = GET_CAN_CTRL_INIB(ctrl_id);
		if ((p_ctrl_inib->use_polling & CAN_USE_POLLING_RX) != 0x00U) {
			if (can_target_polling_rx(ctrl_id) != FALSE) {
				/* [CAN396] ̼ */
				Can_IsrRx(ctrl_id);
			}
		}
	}

  error_exit:
	/* [CAN091] */
	return;
}
#endif /* USE_CAN_RX_POLLING */

/*
 *  [CAN007][CAN099][CAN280][CAN227] Can_MainFunction_BusOff
 */
/* [CAN183] ݡ󥰤ˤХΤѤʤ硤ܴؿʤ */
#ifdef USE_CAN_BUSOFF_POLLING
void
Can_MainFunction_BusOff(void)
{
	uint8				ctrl_id;
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* [CAN104][CAN026][CAN184] */
	CAN_CHECK_INITIALIZED_MF(CANServiceId_MainFunction_BusOff);

	/* [CAN109] ХΤΥݡ󥰤Ԥ */
	for (ctrl_id = 0U; ctrl_id < GET_CONTROLLER_NUM(); ctrl_id++) {
		/* оݥȥ餬ݡ󥰤ξˤΤ߼¹ */
		p_ctrl_inib = GET_CAN_CTRL_INIB(ctrl_id);
		if ((p_ctrl_inib->use_polling & CAN_USE_POLLING_BUSOFF) != 0x00U) {
			if (can_target_polling_busoff(ctrl_id) != FALSE) {
				Can_IsrBusoff(ctrl_id);
			}
		}
	}

  error_exit:
	/* [CAN091] */
	return;
}
#endif /* USE_CAN_BUSOFF_POLLING */

/*
 *  [CAN007][CAN099][CAN280][CAN228] Can_MainFunction_Wakeup
 */
/* [CAN185] ݡ󥰤ˤ륦åΤѤʤ硤ܴؿʤ */
#ifdef USE_CAN_WAKEUP_POLLING
void
Can_MainFunction_Wakeup(void)
{
	uint8				ctrl_id;
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* [CAN104][CAN026][CAN186] */
	CAN_CHECK_INITIALIZED_MF(CANServiceId_MainFunction_Wakeup);

	/* [CAN112] åΤΥݡ󥰤Ԥ */
	for (ctrl_id = 0U; ctrl_id < GET_CONTROLLER_NUM(); ctrl_id++) {
		/* оݥȥ餬ݡ󥰤ξˤΤ߼¹ */
		p_ctrl_inib = GET_CAN_CTRL_INIB(ctrl_id);
		if ((p_ctrl_inib->use_polling & CAN_USE_POLLING_WAKEUP) != 0x00U) {
			if (can_target_polling_wakeup(ctrl_id) != FALSE) {
				Can_IsrWakeup(ctrl_id);
			}
		}
	}

  error_exit:
	/* [CAN091] */
	return;
}
#endif /* USE_CAN_WAKEUP_POLLING */

/*
 *  [CAN368] Can_MainFunction_Mode
 */
void
Can_MainFunction_Mode(void)
{
	uint8					ctrl_id;
	Can_StateTransitionType	ret_state;
	const CAN_CTRL_INIB		*p_ctrl_inib;

	/* [CAN104][CAN026][CAN379] */
	CAN_CHECK_INITIALIZED_MF(CANServiceId_MainFunction_Mode);

	/* [CAN369] ⡼ڤؤ긡ФΥݡ󥰤Ԥ */
	for (ctrl_id = 0U; ctrl_id < GET_CONTROLLER_NUM(); ctrl_id++) {
		/* Can_SetControllerModeư֥ե饰Ƚ */
		if (can_set_controller_mode_flg[ctrl_id] == FALSE) {
			/*
			 * [CAN370] CANȥξ֤ѲȤå
			 *          ѹ줿顤CanIf_ControllerModeIndicationΤ
			 *          CANȥξ֤򹹿
			 */
			ret_state = can_target_get_mode(ctrl_id);

			if (ret_state != can_current_state[ctrl_id]) {
				/* CANȥ֥å */
				p_ctrl_inib = GET_CAN_CTRL_INIB(ctrl_id);

				/* CANȥȽ */
				switch (ret_state) {
				case CAN_T_START:
					CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_STARTED);

					can_current_state[ctrl_id] = CAN_T_START;
					break;
				case CAN_T_STOP:
					CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_STOPPED);

					can_current_state[ctrl_id] = CAN_T_STOP;
					break;
				case CAN_T_SLEEP:
					CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_SLEEP);

					can_current_state[ctrl_id] = CAN_T_SLEEP;
					break;
				case CAN_T_WAKEUP:
					CanIf_ControllerModeIndication(p_ctrl_inib->CanIfCtrlId, CANIF_CS_STOPPED);

					can_current_state[ctrl_id] = CAN_T_WAKEUP;
					break;
				default:
					CAN_DET_REPORT_ERROR(CANServiceId_MainFunction_Mode, CAN_E_TRANSITION);
					break;
				}
			}
		}
	}

  error_exit:
	/* [CAN091] */
	return;
}

/*
 *  [CAN099][CAN035][CAN033] CANλγߥӥ롼
 */
void
Can_IsrRx(uint8 Controller)
{
	Can_IdType			can_id;
	uint8				can_dlc;
	uint8				can_sdu[CAN_MAX_DLC];
	Can_HwHandleType	rbox_idx;
	boolean				ret = TRUE;

	/* (CAN420) ׵Υꥢϡɬפ˱C2ISR¦б */

	while (1) {
		/* ᡼ܥå */
		if (can_target_check_and_get_rbox(Controller, &rbox_idx) == FALSE) {
			/* å̵ */
			break;
		}

		/* ᡼ܥåΥǥåå */
		CAN_CHECK_MAILBOX_INDEX_NUM((rbox_idx <= GET_HRH_NUM(Controller)), CANServiceId_IsrRx);

		/*
		 * IDΥǡ
		 * (CAN012) ǡΰݾڤ
		 * (CAN060) Ƭμǡǡ0ܤǤ˳Ǽ
		 *          μǡ7ܤǤ˳Ǽ
		 * (CAN299)(CAN300) Χǡѿ(can_sdu)˥ԡ
		 */
		if (can_target_get_rdata(Controller, rbox_idx, &can_id, &can_dlc, &can_sdu[0]) == TRUE) {
#ifdef USE_CAN_LPDU_RECEIVE_CALLOUT_FUNCTION
			/* [CAN443] 륢Ƚ */
			ret = CanLpduCalloutFunction(rbox_idx, can_id, can_dlc, can_sdu);
#endif /* USE_CAN_LPDU_RECEIVE_CALLOUT_FUNCTION */
			/* [CAN444] 륢ȽFALSEξ硤³ʤ */
			if (ret == TRUE) {
				/* [CAN279][CAN396]  */
				CanIf_RxIndication(GET_RBOX_CAN_OBJ_ID(Controller, rbox_idx), can_id, can_dlc, &can_sdu[0]);
			}
		}
	}

  error_exit:
	/* [CAN091] */
	return;
}

/*
 *  [CAN099][CAN035][CAN033] CANλγߥӥ롼
 */
void
Can_IsrTx(uint8 Controller)
{
	Can_HwHandleType tbox_idx;

	/* (CAN420) ׵Υꥢϡɬפ˱C2ISR¦б */

	while (1) {
		/* ᡼ܥå */
		if (can_target_check_and_get_tbox(Controller, &tbox_idx) == FALSE) {
			/* å̵ */
			break;
		}

		/* ᡼ܥåΥǥåå */
		CAN_CHECK_MAILBOX_INDEX_NUM((tbox_idx <= GET_HTH_NUM(Controller)), CANServiceId_IsrTx);

		/* [CAN016] ̥쥤ؤ */
		CanIf_TxConfirmation(GET_SAVED_PDU_ID(Controller, tbox_idx));
	}

  error_exit:
	/* [CAN091] */
	return;
}

/*
 *  [CAN099][CAN035][CAN033] CANХγߥӥ롼
 */
void
Can_IsrBusoff(uint8 Controller)
{
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* (CAN420) ׵Υꥢϡɬפ˱C2ISR¦б */

	/* CANȥ֥å */
	p_ctrl_inib = GET_CAN_CTRL_INIB(Controller);

	/* [CAN020] ֤STOPPEDذܹԤ̥쥤 */
	/* (CAN272) STOPPEDذܹԸоݥȥ餬CANͥåȥ˴ͿʤȤݾڤ */
	/* (CAN273) Ԥå硤̥쥤إ󥻥Τ򤻤ˡ򥭥󥻥뤹 */
	/* (CAN274) ϡɥˤ뼫ưХ̵ˤ */
	if (can_target_stop_controller_and_change_interrupt(Controller, p_ctrl_inib) != FALSE) {
		CanIf_ControllerBusOff(Controller);
	}
	else {
		CAN_DET_REPORT_ERROR(CANServiceId_IsrBusoff, CAN_E_FATAL);
	}
}

/*
 *  [CAN099][CAN035][CAN033] CANåγߥӥ롼
 */
void
Can_IsrWakeup(uint8 Controller)
{
	const CAN_CTRL_INIB	*p_ctrl_inib;

	/* (CAN420) ׵Υꥢϡɬפ˱C2ISR¦б */

	/* CANȥ֥å */
	p_ctrl_inib = GET_CAN_CTRL_INIB(Controller);

	/* [CAN270] ֤STOPPEDذܹԤ */
	if (can_target_stop_controller_and_change_interrupt(Controller, p_ctrl_inib) != FALSE) {
		/* [CAN271][CAN364] EcuM */
		if (p_ctrl_inib->CanWakeupSupport != FALSE) {
			EcuM_CheckWakeup(p_ctrl_inib->EcuMWakeupSourceId);
		}
	}
	else {
		CAN_DET_REPORT_ERROR(CANServiceId_IsrWakeup, CAN_E_FATAL);
	}

	/* [CAN269] åоݤΥȥФơʾ岿⤷ʤ */
}

/*
 *  CANȥξִƻ
 */
boolean
can_check_timeout_duration(uint8 Controller, Can_StateTransitionType Transition)
{
	boolean		ret = TRUE;
	TickType	start_time;
	TickType	eval_time;
	TickType	total_eval_time = 0U;
	StatusType	ercd;

	/* ͼ */
	ercd = GetCounterValue(CAN_COUNTER, &start_time);

	/* ͼȽ */
	if (ercd != E_OK) {
		ret = FALSE;
		CAN_DET_REPORT_ERROR(CANServiceId_SetControllerMode, CAN_E_FATAL);
		goto error_exit;
	}

	/* CANȥΥ⡼ɼ */
	while (can_target_get_mode(Controller) != Transition) {
		/* Ƚ */
		can_target_busy_wait();

		/* вᥫͼ */
		ercd = GetElapsedValue(CAN_COUNTER, &start_time, &eval_time);

		/* вᥫͼȽ */
		if (ercd != E_OK) {
			ret = FALSE;
			CAN_DET_REPORT_ERROR(CANServiceId_SetControllerMode, CAN_E_FATAL);
			goto error_exit;
		}

		/* вᥫͤκʬû */
		total_eval_time += eval_time;

		/* [CAN262][CAN264][CAN266][CAN268] CANȥΥ⡼ɼλΤ»֤ޤԤ */
		if ((CAN_COUNTER_TICKS2SEC(total_eval_time)) > CAN_TIMEOUT_DURATION) {
			ret = FALSE;
			break;
		}
	}

  error_exit:
	return(ret);
}


/*
 *  ¸Ǥ̤ݡȵǽ
 *    <CAN395> 顼Хߥ󥰤ϥåȰ¸Τ¸б
 *    <CAN365><CAN366><CAN367> R4.1Ǻ줿ᡤǥХå˴ؤ׵бʤ
 *    <CAN079> R4.1C롼뤬줿ᡤбʤ
 *    <CAN423> ĥեޥåȤˤ̤б
 *    <CAN277><CAN401><CAN402><CAN403><CAN076> ޥ̤ݡ
 *    <CAN278><CAN432><CAN285><CAN286><CAN433><CAN399><CAN400><CAN287><CAN288> 󥻥̤ݡ
 *    <CAN441><CAN442> åܥåΥݡMainFunction̤ݡ
 *    <CAN445><CAN446><CAN447> Icu⥸塼˴ؤ̤ͤݡ
 *    <CAN392> Dem륨顼¸ߤʤᡤ̤ݡ
 *
 *  ϡɥȥꥬȤSLEEPְܹԽФ׵
 *    (CAN257) ϡɥSLEEP⡼ɤ򥵥ݡȤ硤ȥSLEEP֤ڤؤ
 *    (CAN258) ϡɥSLEEP⡼ɤ򥵥ݡȤʤ硤ŪSLEEP֤
 *             ߥ졼ȤȥSTOPPED֤ˤ
 *    (CAN404) ŪSLEEP⡼ɤδ֤ϡȥSTOPPED֤ݻ
 *
 *  ¾λ
 *    [CAN240] Mcu⥸塼ؤ׵Ǥ
 *    [CAN455] CanIf⥸塼ؤ׵Ǥ
 *    [CAN058][CAN234][CAN235] Ϣ볰I/Fؤ׵Ǥ
 *    [CAN459] 桼ؤջǤ
 *    [CAN110] MainFunctionμ¹Խؤ׵᤬ʤᡤб
 *    (CAN239) I/OݡȤνPort⥸塼ǹԤȵꤵƤ뤬
 *             Port⥸塼άơOS뤤ϳư¸ǽǽȤ
 *    <CAN418> Can⥸塼ΤߤǻѤ䥰ХѿؿܥեǤΤ
 *             ȵꤵƤ뤬åȰ¸/¸ڤʬΤᡤ
 *             ̥եǤǽȤ
 *    [CAN448][CAN999] ׵ͤǤϤʤ
 */
