/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2014 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: os.c 907 2014-12-24 02:47:55Z shigihara $
 */

#include "Os.h"
#include "Can.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "sysmod/banner.h"
#include "target_serial.h"
#include "prc_sil.h"

#define CAN_USE_CTRL_NUM	1U

TASK(MainTask){
	volatile uint32 i;
	uint8			cnt;
	uint8			Hth;
	uint8			data[8] = {
		0x00U, 0x01U, 0x02U, 0x03U,
		0x04U, 0x05U, 0x06U, 0x07U
	};
	Can_PduType		send_data;

	Can_Init(NULL_PTR);
	syslog(LOG_NOTICE, "== Can_Init ==");

	for (i = 0; i < CAN_USE_CTRL_NUM; i++) {
		Can_SetControllerMode(i, CAN_T_START);
	}

	syslog(LOG_NOTICE, " ");
	syslog(LOG_NOTICE, "== Can_SetControllerMode ==");
	syslog(LOG_NOTICE, " ");

	send_data.length = 8U;
	send_data.sdu = data;
	send_data.swPduHandle = 3U;
	send_data.id = 0x10U;
	Hth = 3U;
	cnt = 0U;

	while (1) {
		syslog(LOG_NOTICE, "Can_Write(%d) CAN-ID:0x%x", Hth, send_data.id);
		for (i = 0U; i < send_data.length; i++) {
			syslog(LOG_NOTICE, "DATA[%d]:0x%x", i, send_data.sdu[i]);
		}
		Can_Write(Hth, &send_data);
		syslog(LOG_NOTICE, "");

		/* ȥ󥯥 */
		cnt++;

		if (cnt >= CAN_USE_CTRL_NUM) {
			/*  */
			send_data.id = 0x10U;

			/* HOH */
			Hth = 3U;

			/* ȥꥢ */
			cnt = 0U;
		}
		else {
			/* chHOH˹ */
			Hth += 4U;

			/* chCAN-ID򹹿 */
			send_data.id++;
		}

		/*  */
		for (i = 0U; i < 10000000U; i++) {
		}
	}

	ShutdownOS(E_OK);
}

boolean
CanCalloutFunction(uint8 Hrh, Can_IdType CanId, uint8 CanDlc, const uint8 *CanSduPtr)
{
	uint8 i;

	syslog(LOG_NOTICE, "CanCalloutFunction:Hrh = 0x%x, CanId = 0x%x, CanDlc = 0x%x", Hrh, CanId, CanDlc);

	for (i = 0U; i < CanDlc; i++) {
		syslog(LOG_NOTICE, "CanCalloutFunction:CanSduPtr[%d] = 0x%x", i, CanSduPtr[i]);
	}

	return(TRUE);
}

ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	syslog(LOG_NOTICE, "## ProtectionHook is called !! (%d)", FatalError);

	return(PRO_SHUTDOWN);
}

void
StartupHook(void)
{
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();
}

sint32
main(void)
{
	StartOS(MainApp);
	while (1) ;
	return(0);
}
